unit Unit0021;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    LabelA2: TLabel;
    LabelA1: TLabel;
    LabelA3: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    ix,iy : Integer ;
    px,py,mm_dot : Double ;
    x1,y1,x2,y2 : Double ;
    procedure GCLS ;    // ʃNA
    procedure GDRAW ;   // ʍ}
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// 
procedure TForm1.FormShow(Sender: TObject);
begin
   Button1Click(Sender);
end;

// }
procedure TForm1.Button1Click(Sender: TObject);
var
   p1,p2 : Double ;
begin
   GCLS ;   // ʂNA
   px := StrToFloat(Edit1.Text);
   py := StrToFloat(Edit2.Text);
   p1 := ix / px ;
   p2 := iy / py ;
   if (p1 < p2) then mm_dot := p1 else mm_dot := p2 ;
   Edit3.Text := FloatToStr(mm_dot);
   x1 := - ix / 2.0 / mm_dot ;
   y1 := - iy / 2.0 / mm_dot ;
   x2 :=   ix / 2.0 / mm_dot ;
   y2 :=   iy / 2.0 / mm_dot ;
   LabelA1.Caption := '( '+FloatToStr(x1)+' , '+FloatToStr(y1)+' )';
   LabelA2.Caption := '( '+FloatToStr(x2)+' , '+FloatToStr(y2)+' )';
   GDRAW ;  // ʂ}
end;

// wmm_dotŕ\
procedure TForm1.Button2Click(Sender: TObject);
begin
   GCLS ;   // ʂNA
   mm_dot := StrToFloat(Edit3.Text);
   x1 := - ix / 2.0 / mm_dot ;
   y1 := - iy / 2.0 / mm_dot ;
   x2 :=   ix / 2.0 / mm_dot ;
   y2 :=   iy / 2.0 / mm_dot ;
   LabelA1.Caption := '( '+FloatToStr(x1)+' , '+FloatToStr(y1)+' )';
   LabelA2.Caption := '( '+FloatToStr(x2)+' , '+FloatToStr(y2)+' )';
   GDRAW ;  // ʂ}
end;

// }EX𓮂
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   tx,ty : double ;
begin
   tx := x1 + X / mm_dot ;
   ty := y2 - Y / mm_dot ;
   LabelA3.Caption := '( '+FloatToStr(tx)+' , '+FloatToStr(ty)+' )';
end;

// ʂNA
procedure TForm1.GCLS ;
begin
   Image1.Picture := nil ;
   with Image1.Canvas do begin
      ix := Image1.Width ;
      iy := Image1.Height ;
      // ʂ
      with Pen do begin
         Mode  := pmCopy ;
         Color := clWhite;
         Style := psSolid;
         Width := 1;
      end;
      with Brush do begin
         Color := clWhite;
         Style := bsSolid;
      end;
      Rectangle(0,0,ix,iy);
   end;
end;

// ʂ}
procedure TForm1.GDRAW ;
var
   ax1,ay1,ax2,ay2 : Integer ;
begin
   with Image1.Canvas do begin
      // pg
      ax1 := Round( ( -px/2 - x1 ) * mm_dot );
      ay1 := Round(-( -py/2 - y2 ) * mm_dot );
      ax2 := Round( (  px/2 - x1 ) * mm_dot );
      ay2 := Round(-(  py/2 - y2 ) * mm_dot );
      Pen.Color := clBlue ;
      Brush.Style := bsClear ;
      Rectangle(ax1,ay1,ax2,ay2);
      // _
      ax1 := Round( ( 0.0 - x1 ) * mm_dot );
      ay1 := Round(-( 0.0 - y2 ) * mm_dot );
      Pen.Color := clRed ;
      MoveTo(ax1-5,ay1);   LineTo(ax1+6,ay1);
      MoveTo(ax1,ay1-5);   LineTo(ax1,ay1+6);
      // lp`
      ax1 := Round( ( -20 - x1 ) * mm_dot );
      ay1 := Round(-( -10 - y2 ) * mm_dot );
      ax2 := Round( (  20 - x1 ) * mm_dot );
      ay2 := Round(-(  10 - y2 ) * mm_dot );
      Pen.Color := clBlack ;
      Brush.Style := bsClear ;
      Rectangle(ax1,ay1,ax2,ay2);
   end;
end;

end.
